unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    Edit1: TEdit;
    Label1: TLabel;
    OKbtn: TBitBtn;
    clearBtn: TBitBtn;
    Aedit: TEdit;
    Bedit: TEdit;
    Cedit: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    setABCbtn: TBitBtn;
    debugcheck: TCheckBox;
    procedure OKbtnClick(Sender: TObject);
    procedure clearBtnClick(Sender: TObject);
    procedure setABCbtnClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure AeditKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses xlate,eqdrawer;

procedure TForm1.OKbtnClick(Sender: TObject);
var xlatecode : byte;
begin
 setdebugmode(paintbox1,debugcheck.checked);
 xlateEquation(edit1.Text,xlatecode);
 label1.Caption := getmessage(xlatecode);
 if (xlatecode = 0) and (debugcheck.checked = false) then drawEquation;
end;

procedure TForm1.clearBtnClick(Sender: TObject);
begin
 edit1.Text := '';
 label1.Caption := '';
 activecontrol := edit1;
end;

procedure TForm1.setABCbtnClick(Sender: TObject);
var d : double;
begin
 label1.Caption := '';
 try
  d := strtofloat(Aedit.text);
  setconstant('a',d);
 except
  label1.Caption := 'A error';
  exit;
 end;
 try
  d := strtofloat(Bedit.text);
  setconstant('b',d);
 except
  label1.Caption := 'B error';
  exit;
 end;
 try
  d := strtofloat(Cedit.text);
  setconstant('c',d);
 except
  label1.Caption := 'C error';
  exit;
 end;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
//CR simulates OK button press
begin
 if key = #13 then OKbtnclick(self);
end;

procedure TForm1.AeditKeyPress(Sender: TObject; var Key: Char);
begin
 if not (key in ['0'..'9',#08,'-','.']) then key := #0;
end;

end.
